config/routes.rb
Rails.application.routes.draw do
  resources :phone_lists
  get 'map' ,to:'map#show'

  get 'admin' ,to:'links#admin'
  
  devise_for :users
  resources :links do
    resources :students
  end

  resources :users, only: [:index, :destroy]
  resources :users
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html
  
  # Defines the root path route ("/")
  root to: 'links#index'
  # root "articles#index"
end

app/models/phone_list.rb
class PhoneList < ApplicationRecord
    # validates :link_id, presence: true
end

app/controllers/phone_lists_controller.rb
class PhoneListsController < ApplicationController
  before_action :set_phone_list, only: %i[ show edit update destroy ]

  # GET /phone_lists or /phone_lists.json
  def index
    @phone_lists = if params[:search]
      PhoneList.where("name LIKE ?", "%#{params[:search]}%")
    else
      PhoneList.all
    end
  
    respond_to do |format|
      format.html
      format.js
    end
  end

  # GET /phone_lists/1 or /phone_lists/1.json
  def show
  end

  def search
    @phone_lists = PhoneList.find(params[:id])
  end

  # GET /phone_lists/new
  def new
    @phone_list = PhoneList.new
  end

  # GET /phone_lists/1/edit
  def edit
  end

  # POST /phone_lists or /phone_lists.json
  def create
    @phone_list = PhoneList.new(phone_list_params)

    respond_to do |format|
      if @phone_list.save
        format.html { redirect_to phone_list_url(@phone_list), notice: "Phone list was successfully created." }
        format.json { render :show, status: :created, location: @phone_list }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @phone_list.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /phone_lists/1 or /phone_lists/1.json
  def update
    respond_to do |format|
      if @phone_list.update(phone_list_params)
        format.html { redirect_to phone_list_url(@phone_list), notice: "Phone list was successfully updated." }
        format.json { render :show, status: :ok, location: @phone_list }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @phone_list.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /phone_lists/1 or /phone_lists/1.json
  def destroy
    @phone_list.destroy

    respond_to do |format|
      format.html { redirect_to phone_lists_url, notice: "Phone list was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_phone_list
      @phone_list = PhoneList.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    def phone_list_params
      params.require(:phone_list).permit(:name, :phone_number, :link_id)
    end
end

app/helpers/phone_lists_helper.rb
module PhoneListsHelper
end

app/views/phone_lists/_form.html.erb
<%= form_with(model: phone_list) do |form| %>
  <% if phone_list.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(phone_list.errors.count, "error") %> prohibited this phone_list from being saved:</h2>

      <ul>
        <% phone_list.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :name, style: "display: block" %>
    <%= form.text_field :name %>
  </div>

  <div>
    <%= form.label :phone_number, style: "display: block" %>
    <%= form.text_field :phone_number %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/phone_lists/_phone_list.html.erb
<div id="<%= dom_id phone_list %>">
  <p>
    <strong>Name:</strong>
    <%= phone_list.name %>
  </p>

  <p>
  <strong>Phone number:</strong>
  <a href="tel:<%= phone_list.phone_number %>">
    <u><%= phone_list.phone_number %></u>
  </a>
</p>



</div>

app/views/phone_lists/edit.html.erb
<h1>Editing phone list</h1>

<%= render "form", phone_list: @phone_list %>

<br>

<div>
  <%= link_to "Show this phone list", @phone_list %> |
  <%= link_to "Back to phone lists", phone_lists_path %>
</div>

app/views/phone_lists/index.html.erb
<p style="color: green"><%= notice %></p>

<h1>Phone lists</h1>

<%= form_tag phone_lists_path, method: :get, remote: true, id: "search-form" do %>
  <div class="field">
    <%= text_field_tag :search, params[:search], placeholder: "Search phone lists..." %>
  </div>
  <div class="actions">
    <%= submit_tag "Search", name: nil, class: "btn btn-primary" %>
  </div>
<% end %>


<div id="phone_lists">
  <% @phone_lists.each do |phone_list| %>
    <table>
      <tr>
        <td><%= render phone_list %></td>
        <% if user_signed_in? && current_user.username == 'admin' %>
          <td><%= link_to "Show this phone list", phone_list %></td>
        <% end %>
      </tr>
    </table>
  <% end %>
</div>


</br>
<%= link_to "Back", links_path %> 



<!-- <h2>Phone Call</h2>

<h2>Who do you want to contact?</h2>

<h3>Police</h3>
<h5>Tel: 1155 or 191 or +662-287-3101</h5>

<h3>Thammasat Hospital</h3>
<h5>Tel: 02-926-9999</h5>

<h3>Hospital (sos)</h3>
<h5>Tel: 1169 or 032-616-888</h5>

<h3>Fire Fighter</h3>
<h5>Tel: 191 or 192 or 199</h5>

<h3>AIT Security Guard</h3>
<h5>Tel: 098-374-8863 (mr.x)</h5>
<h5>Tel: 095-229-5813 (mr.y)</h5>
<h5>Tel: 082-663-8194 (mr.z)</h5>

<h3>AIT Repair man</h3>
<h5>Tel: 092-639-7721 (mr.a)</h5>
<h5>Tel: 096-811-5399 (mr.b)</h5>




<%= link_to "Back", links_path %> -->

app/views/phone_lists/new.html.erb
<h1>New phone list</h1>

<%= render "form", phone_list: @phone_list %>

<br>

<div>
  <%= link_to "Back to phone lists", phone_lists_path %>
</div>

app/views/phone_lists/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @phone_list %>

<div>
  <%= link_to "Edit this phone list", edit_phone_list_path(@phone_list) %> |
  <%= link_to "Back to phone lists", phone_lists_path %>

  <%= button_to "Destroy this phone list", @phone_list, method: :delete %>
</div>